# shoutcast-lib.pl
# Functions for storing custom commands

do '../web-lib.pl';
&init_config();
%access = &get_module_acl();

sub read_text {
	my ($name) = @_;
	$filename=$module_root_directory."/text/".$name.".text";
	$text=&read_textfile($filename,0,0);
	return $text;
}

sub read_comment {
	my ($name) = @_;
	$filename=$module_root_directory."/text/".$name.".text";
  	$text=&read_textfile($filename,0,1);
	return $text;
}

sub read_logfile{
  $name=$config{'log_file'};
  $text=&read_textfile($name,1,0);
	return $text;
}

sub read_textfile {
   my($name, $eolflag, $commentflag)=@_;
   my $text;
   my $filename;
   my $flag=0;
    
   $filename=$name;
   
   &lock_file($filename);
   open (IFILE, "< $filename")
     or $flag=1;
     #die "can't open file $filename: $!\n";
 
   if ($flag==0) {
 	   @textfile=<IFILE>; 
	   for ($i=0; $i < @textfile; $i++) {
	     $line=$textfile[$i];
	     chop $line;            # abschliessendes \n entfernen
	     $line = ($commentflag ? "; " . $line : $line);
	     
	     $text .= ($eolflag ? $line . "<BR>" : $line);	     	     
	     $text .= "\n";
	   }

	  close(IFILE);  
	  &unlock_file($filename);
  }
  return $text;
}


sub ltrim {
   my($string)=@_;
   $result=$string;
   
   while (substr($result, 0, 1)  eq " ") {
      $result=substr($result,1,length($result)-1);
   }
   return $result;
}   
 

sub purekey {
	my ($key) = @_;
	my	$key_pure=$key;
	 	
	if ( substr($key, 0, 1)  eq ";" ) {
	  $key_pure=&ltrim(substr($key,1,length($key)-1));
	}
	    
	if (rindex($key_pure,' ') < 1) {
		return $key_pure;
 	}
 	elif {
 		return "";
 	}

}

sub read_config_template (\%conftemplates) {
  my $filename="./sc_serv.conf";
    
  &read_file($filename, \%conftemplates); 	
  return \%conftemplates;
}


sub copy_list_entries {
	($sourceref, $destref) = @_;
	
	%result=%$destref;
	%source=%$sourceref;
	
	foreach $key (sort keys %result) {
	 	$key_pure=&purekey($key);
	 	if ($key_pure ne "") {
	 		if (exists($source{$key})) {
	  	 	$result{$key}=$source{$key};
	  	}
		}		
	}
	return \%result;
}

sub aggregate_lists (\%result)  {
	($sourceref, $destref) = @_;
	
	%result=%$destref;
	%source=%$sourceref;
	
	foreach $key (sort keys %result) {
	 	$key_pure=&purekey($key);
	 	if ($key_pure ne "") {	  	
		  if (exists($source{$key})) {		
		   	$result{$key}=$source{$key};
		  }
		}		
	}
	
	foreach $key (sort keys %source) {	
	  $key_pure=&purekey($key);
	  if ($key_pure ne "") {
			if (! exists($result{$key})) {
		   	 $result{$key}=$source{$key};
			}
		}
	}
	return \%result;
}

sub save_params {
	($ref) = @_;
	
	%hash=%$ref;
	$filename=$config{'config_file'};
	
	&lock_file($filename);
	open(outfile, ">$filename") || return;
	print outfile &read_comment('header');
	foreach $key (sort keys %hash) {	
		$key_pure=&purekey($key);		
		$out = $key . "=" . $hash{$key};
		print outfile &read_comment($key_pure);
		print outfile "$out\n\n";
	}
	close(outfile);
	&unlock_file($filename);

}
